#include "cfloatex.h"

CFloatEX		CFloatEX::operator+(void)
{
	return *this;
}

CFloatEX		CFloatEX::operator-(void)
{
	CFloatEX	temp;

	floatex_echsign(val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::operator++(void)
{
	floatex_inc(val);
	return *this;
}

CFloatEX		CFloatEX::operator--(void)
{
	floatex_dec(val);
	return *this;
}

CFloatEX		CFloatEX::operator+(const CFloatEX &n)
{
	CFloatEX	temp;

	floatex_eadd(val,(PFLOATEX)n.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::operator-(const CFloatEX &n)
{
	CFloatEX	temp;

	floatex_esub(val,(PFLOATEX)n.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::operator*(const CFloatEX &n)
{
	CFloatEX	temp;

	floatex_emul(val,(PFLOATEX)n.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::operator/(const CFloatEX &n)
{
	CFloatEX	temp;

	floatex_ediv(val,(PFLOATEX)n.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::operator%(const CFloatEX &n)
{
	CFloatEX	temp;

	floatex_efmod(val,(PFLOATEX)n.val,temp.val);
	return temp;
}

CFloatEX		CFloatEX::operator+(const double n)
{
	CFloatEX	temp = n;

	return *this + temp;
}

CFloatEX		CFloatEX::operator-(const double n)
{
	CFloatEX	temp = n;

	return *this - temp;
}

CFloatEX		CFloatEX::operator*(const double n)
{
	CFloatEX	temp = n;

	return *this * temp;
}

CFloatEX		CFloatEX::operator/(const double n)
{
	CFloatEX	temp = n;

	return *this / temp;
}

CFloatEX		CFloatEX::operator%(const double n)
{
	CFloatEX	temp = n;

	return *this % temp;
}

CFloatEX		CFloatEX::operator+=(const CFloatEX &n)
{
	floatex_add(val,(PFLOATEX)n.val);
	return *this;
}

CFloatEX		CFloatEX::operator-=(const CFloatEX &n)
{
	floatex_sub(val,(PFLOATEX)n.val);
	return *this;
}

CFloatEX		CFloatEX::operator*=(const CFloatEX &n)
{
	floatex_mul(val,(PFLOATEX)n.val);
	return *this;
}

CFloatEX		CFloatEX::operator/=(const CFloatEX &n)
{
	floatex_div(val,(PFLOATEX)n.val);
	return *this;
}

CFloatEX		CFloatEX::operator%=(const CFloatEX &n)
{
	floatex_fmod(val,(PFLOATEX)n.val);
	return *this;
}

CFloatEX		CFloatEX::operator+=(const double n)
{
	CFloatEX	temp = n;

	return *this += temp;
}

CFloatEX		CFloatEX::operator-=(const double n)
{
	CFloatEX	temp = n;

	return *this -= temp;
}

CFloatEX		CFloatEX::operator*=(const double n)
{
	CFloatEX	temp = n;

	return *this *= temp;
}

CFloatEX		CFloatEX::operator/=(const double n)
{
	CFloatEX	temp = n;

	return *this /= temp;
}

CFloatEX		CFloatEX::operator%=(const double n)
{
	CFloatEX	temp = n;

	return *this %= temp;
}

