#include <string.h>
#include "cfloatex.h"

CFloatEX		CFloatEX::operator=(const long n)
{
	floatex_longto(n,val);
	return *this;
}

CFloatEX		CFloatEX::operator=(const unsigned long n)
{
	floatex_ulongto(n,val);
	return *this;
}

CFloatEX		CFloatEX::operator=(const double n)
{
	floatex_doubleto(n,val);
	return *this;
}

CFloatEX		CFloatEX::operator=(const INT64 n)
{
	floatex_int64to((INT64)n,val);
	return *this;
}

CFloatEX		CFloatEX::operator=(const UINT64 n)
{
	floatex_uint64to((UINT64)n,val);
	return *this;
}

CFloatEX		CFloatEX::operator=(const char *pstr)
{
	str_to(pstr);
	return *this;
}

long			CFloatEX::to_long(void)
{
	return floatex_tolong(val);
}

unsigned long	CFloatEX::to_ulong(void)
{
	return floatex_toulong(val);
}

double			CFloatEX::to_double(void)
{
	return floatex_todouble(val);
}

INT64			CFloatEX::to_int64(void)
{
	return floatex_toint64(val);
}

UINT64			CFloatEX::to_uint64(void)
{
	return floatex_touint64(val);
}

extern int		bInitSuccess; // init.cpp

char *			CFloatEX::to_str(const char *pbuffer)
{
	if (!pbuffer)
		pbuffer = private_buf;

	char	*pdest = (char *)pbuffer;

	if (bInitSuccess)
		floatex_ldstr_ldtoa(val,pdest);
	else
		*pdest = 0;

	return pdest;
}

char *			CFloatEX::to_str(
					const char	*pbuffer,
					int			bufsize,
					const char	*pform)
{
	char	*pdest = (char *)pbuffer;

	if (bInitSuccess)
		floatex_ldstr_ldtoa_f(
			val,(char *)pform,strlen(pform),pdest,bufsize);
	else
		*pdest = 0;

	return pdest;
}

CFloatEX		CFloatEX::str_to(const char *pstr,char **ppstop)
{
	if (bInitSuccess)
		floatex_ldstr_strtold((char *)pstr,ppstop,val);
	else
		floatex_setz(val);

	return *this;
}
