#include "cfloatex.h"

static unsigned int		sem;
static unsigned int		oldcw;
int						bInitSuccess;

void	common_init(void)
{
	if (!sem++){
		oldcw = floatex_storecw();
		floatex_loadcw(FEX_MCW_EM | FEX_PC_64 | FEX_RC_NEAR);
		bInitSuccess = floatex_ldstr_init();
	}
}

CFloatEX::CFloatEX()
{
	common_init();
	floatex_setz(val);
}

CFloatEX::CFloatEX(const CFloatEX &n)
{
	common_init();
	*this = n;
}

CFloatEX::CFloatEX(const long n)
{
	common_init();
	*this = n;
}

CFloatEX::CFloatEX(const unsigned long n)
{
	common_init();
	*this = n;
}

CFloatEX::CFloatEX(const double n)
{
	common_init();
	*this = n;
}

CFloatEX::CFloatEX(const INT64 n)
{
	common_init();
	*this = n;
}

CFloatEX::CFloatEX(const UINT64 n)
{
	common_init();
	*this = n;
}

CFloatEX::CFloatEX(const char *pstr)
{
	common_init();
	*this = pstr;
}

CFloatEX::~CFloatEX()
{
	if (!--sem){
		floatex_ldstr_term();
		floatex_loadcw(oldcw);
	}
}

