#include <ctype.h>
#include <excpt.h>
#include "floatex.h"
#include "sc_mod.h"

typedef struct {
	char			*pstr;
	PFLOATEX		param[2];
} SC_ARG,*PSC_ARG;

/* 󔒂΂ */
static char 	*jmpspc(char *ptr)
{
	while(isspace(*ptr))
		ptr++;
	return ptr;
}

#define ABORT_SC			floatex_raise_exception(FEX_STAT_IE,0)

static PFLOATEX		addsub(PSC_ARG,PFLOATEX);

/* l̎擾 */
static PFLOATEX		getval(PSC_ARG parg,PFLOATEX pres)
{
	PFLOATEX	ptr;
	int 		c,s = 0;

	switch(*(parg->pstr = jmpspc(parg->pstr))){ /* ꍇ */
		case	'-': s = 1;
		case	'+': parg->pstr = jmpspc(parg->pstr + 1);
	}

	switch(c = *parg->pstr){
		/*  */
		case	'(':
				parg->pstr++;
				addsub(parg,pres); /* ʓvZ */

				/* ʂŏIĂȂꍇ̓G[ */
				if (*parg->pstr != ')')
					ABORT_SC;

				parg->pstr++;
				break;

		/* ϐ */
		case	'X':
		case	'Y':
				c += 'a' - 'A'; /* ɕϊ */
		case	'x':
		case	'y':

				/* ȕϐw肵ꍇ̓G[ */
				if ((ptr = parg->param[c - 'x']) == 0)
					ABORT_SC;

				floatex_copy(pres,ptr);
				parg->pstr++;
				break;

		/* ̑͐lƌȂ */
		default:
				/*
				  ⏬_ł͖ꍇ
				  ܂͐lɕϊłȂꍇ̓G[
				*/
				if (!isdigit(c) && c != '.' ||
					floatex_ldstr_strtold(parg->pstr,&parg->pstr,pres))
					ABORT_SC;
	}

	if (!floatex_isnormal(pres))
		ABORT_SC;

	if (s)
		floatex_chsign(pres);

	return pres;
}

/* ׂ */
static PFLOATEX		power(PSC_ARG parg,PFLOATEX pres)
{
	FLOATEX 	val,n;

	for(getval(parg,val);*(parg->pstr = jmpspc(parg->pstr)) == '^';){
		parg->pstr++;
		floatex_pow(val,getval(parg,n),val);
	}

	return floatex_copy(pres,val);
}

/* 揜ZA] */
static PFLOATEX		muldiv(PSC_ARG parg,PFLOATEX pres)
{
	FLOATEX 	val,n;

	power(parg,val);

	while(1){
		switch(*(parg->pstr = jmpspc(parg->pstr))){
			case	'*':
					parg->pstr++;
					floatex_mul(val,power(parg,n));
					break;
			case	'/':
					parg->pstr++;
					floatex_div(val,power(parg,n));
					break;
			case	'%':
					parg->pstr++;
					floatex_fmod(val,power(parg,n));
					break;
			default:
					return floatex_copy(pres,val);
		}
	}
}

/* Z */
static PFLOATEX		addsub(PSC_ARG parg,PFLOATEX pres)
{
	FLOATEX 	val,n;

	muldiv(parg,val);

	while(1){
		switch(*(parg->pstr = jmpspc(parg->pstr))){
			case	'+':
					parg->pstr++;
					floatex_add(val,muldiv(parg,n));
					break;
			case	'-':
					parg->pstr++;
					floatex_sub(val,muldiv(parg,n));
					break;
			default:
					return floatex_copy(pres,val);
		}
	}
}

int __cdecl		stringcalc(
					char		*pstr,
					PFLOATEX	px,
					PFLOATEX	py,
					PFLOATEX	presult)
{
	unsigned int	oldcw;
	int 			ret;
	SC_ARG			arg;

	floatex_clear87();
	oldcw = floatex_storecw();
	floatex_loadcw(FEX_PC_64 | FEX_RC_NEAR | FEX_EM_INEXACT);

	__try{
		arg.pstr = pstr;
		arg.param[0] = px;
		arg.param[1] = py;

		addsub(&arg,presult);

		/*
		  kȊȌꍇA܂͌ʂ
		  m[}l[łȂꍇ̓G[Ƃ
		*/
		ret = !*arg.pstr && floatex_isnormal(presult);
	}
	__except(EXCEPTION_EXECUTE_HANDLER){
		floatex_reset();
		ret = 0;
	}

	if (!ret)
		floatex_setz(presult);

	floatex_loadcw(oldcw);

	return ret;
}
