#ifndef ___LOCAL_H_ONCE
#define ___LOCAL_H_ONCE

#define IDM_CAPTUREBMP		1001
#define IDM_PAUSE			1002
#define IDM_CONTINUE		1003
#define	IDM_EXIT			1004

#define SCREEN_WIDTH		GetSystemMetrics(SM_CXSCREEN)
#define SCREEN_HEIGHT		GetSystemMetrics(SM_CYSCREEN)

#define WIDTH(RECTBASE)		((RECTBASE).right - (RECTBASE).left)
#define HEIGHT(RECTBASE)	((RECTBASE).bottom - (RECTBASE).top)

typedef UINT	(__stdcall *THREAD_ROUTINE)(LPVOID);

typedef struct	{
	UINT		wID;
	LPSTR		pstr;
	HMENU		hSubMenu;
} MENUITEM,*PMENUITEM;

INT			OnCreate(HWND);
VOID		OnDestroy(HWND);
VOID		OnPaint(HWND);
VOID		OnPopupMenu(HWND);
VOID		OnCapture(HWND);
VOID		OnPause(HWND);
VOID		OnContinue(HWND);
VOID		OnLButtonDown(HWND);
HMENU		MakePopupMenu(PMENUITEM,INT);

LRESULT CALLBACK		WindowProc(HWND,UINT,WPARAM,LPARAM);

#ifdef ___MAKE_DLL
CRITICAL_SECTION		gcs;
DRAW_ROUTINE			gpfDraw;
DWORD					gnWidth,gnHeight;
HDC						ghDC,ghWDC;
HBITMAP					ghBmp;
HBRUSH					ghBrush;
HPEN					ghPen;
HANDLE					ghThread,ghStopEvent;
UINT					guThreadID;
HMENU					ghPopupMenu;
BOOL					gbPause;
#else
extern CRITICAL_SECTION	gcs;
extern DRAW_ROUTINE		gpfDraw;
extern DWORD			gnWidth,gnHeight;
extern HDC				ghDC,ghWDC;
extern HBITMAP			ghBmp;
extern HBRUSH			ghBrush;
extern HPEN				ghPen;
extern HANDLE			ghThread,ghStopEvent;
extern UINT				guThreadID;
extern HMENU			ghPopupMenu;
extern BOOL				gbPause;
#endif

#endif
