#include <windows.h>
#include "winctrl.h"
#include "local.h"

LRESULT CALLBACK		WindowProc(
								HWND		hWnd,
								UINT		uMsg,
								WPARAM		wParam,
								LPARAM		lParam)
{
	switch(uMsg){
		case	WM_CREATE:
				return OnCreate(hWnd); /* OnCreate.c */

		case	WM_DESTROY:
				OnDestroy(hWnd); /* OnDestroy.c */
				PostQuitMessage(0);
				break;

		case	WM_PAINT:
				OnPaint(hWnd); /* OnPaint.c */
				break;

		case	WM_RBUTTONDOWN:
				OnPopupMenu(hWnd); /* OnRButtonDown.c */
				break;

		case	WM_LBUTTONDOWN:
				OnLButtonDown(hWnd); /* OnLButtonDown.c */
				break;

		case	WM_COMMAND:
				switch(LOWORD(wParam)){
					case	IDM_CAPTUREBMP:
							OnCapture(hWnd); /* OnCapture.c */
							break;

					case	IDM_PAUSE:
							OnPause(hWnd); /* pause.c */
							break;

					case	IDM_CONTINUE:
							OnContinue(hWnd); /* pause.c */
							break;

					case	IDM_EXIT:
							PostMessage(hWnd,WM_DESTROY,0L,0L);
							break;
				}

		default:
				return DefWindowProc(hWnd,uMsg,wParam,lParam);
	}
	return 0;
}
