/*
  x87 g{x_ZCu
              by RF(Y.Koyama) 2015-2016
*/
#ifndef ___FLOATEX_H_ONCE
#define ___FLOATEX_H_ONCE

#ifdef __cplusplus
extern "C"{
#endif

#define FLOATEX_SIZE			10 /* FLOATEX^̃TCY */

/* FLOATEX ^ */
typedef unsigned char		FLOATEX[FLOATEX_SIZE],*PFLOATEX;

typedef FLOATEX 			*FLOATEX_TBLPTR; /* FLOATEX ^z̃|C^ */

/* INT64 ^AUINT64 ^ */
#ifndef FEX_DISABLE_INT64
typedef __int64 			INT64,*PINT64;
typedef unsigned __int64	UINT64,*PUINT64;

#define ___FEX_I64			INT64
#define ___FEX_PI64			PINT64
#define ___FEX_UI64			UINT64
#define ___FEX_PUI64		PUINT64

#else

#define ___FEX_I64				__int64
#define ___FEX_PI64				__int64 *
#define ___FEX_UI64				unsigned __int64
#define ___FEX_PUI64 			unsigned __int64 *

#endif

typedef union { /* FLOATEX_VALUE \ */
	FLOATEX 			fex_val;

#ifdef FEX_LONG_DOUBLE_SUPPORT
	long double 		ld_val;
#endif

	struct {
		___FEX_UI64		mantissa;
		unsigned int	exp : 15;
		unsigned int	sign : 1;
	} bits;
} FLOATEX_VALUE,*PFLOATEX_VALUE;

/*****************************************************************************/

#ifdef ___FLOATEX_MAKE_DLL
#define ___FEX_DECL		__declspec(dllexport)
#else
#define ___FEX_DECL		__declspec(dllimport)
#endif

___FEX_DECL PFLOATEX __stdcall floatex_add(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_sub(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_mul(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_div(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_fmod(PFLOATEX,PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_eadd(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_esub(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_emul(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_ediv(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_efmod(PFLOATEX,PFLOATEX,PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_inc(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_dec(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_mul2(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_mul10(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_mulx(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_div2(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_div10(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_fmod10(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_reciprocal(PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_einc(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_edec(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_emul2(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_emul10(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_emulx(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_ediv2(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_ediv10(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_efmod10(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_ereciprocal(PFLOATEX,PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_fmod_ieee(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_fmod10_ieee(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_efmod_ieee(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_efmod10_ieee(PFLOATEX,PFLOATEX);

___FEX_DECL int __stdcall		floatex_comp(PFLOATEX,PFLOATEX);
___FEX_DECL int __stdcall		floatex_ucomp(PFLOATEX,PFLOATEX);
___FEX_DECL int __stdcall		floatex_nzero(PFLOATEX);

___FEX_DECL int __stdcall		floatex_isdenormal(PFLOATEX);
___FEX_DECL int __stdcall		floatex_isnormal(PFLOATEX);
___FEX_DECL int __stdcall		floatex_isinfinite(PFLOATEX);
___FEX_DECL int __stdcall		floatex_isnan(PFLOATEX);
___FEX_DECL int __stdcall		floatex_issnan(PFLOATEX);
___FEX_DECL int __stdcall		floatex_isqnan(PFLOATEX);
___FEX_DECL int __stdcall		floatex_isunsupport(PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_abs(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_nabs(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_chsign(PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_eabs(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_enabs(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_echsign(PFLOATEX,PFLOATEX);
___FEX_DECL int __stdcall		floatex_sgn(PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_copy(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_copysign(
									PFLOATEX,PFLOATEX,PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_setz(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_int(PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_eint(PFLOATEX,PFLOATEX);
___FEX_DECL void __stdcall 		floatex_modf(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL void __stdcall 		floatex_frexp(PFLOATEX,int *,PFLOATEX);
___FEX_DECL void * __stdcall	floatex_ldexp(PFLOATEX,int,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall	floatex_nextafter(PFLOATEX,PFLOATEX,PFLOATEX);

___FEX_DECL long __stdcall 			floatex_tolong(PFLOATEX);
___FEX_DECL unsigned long __stdcall	floatex_toulong(PFLOATEX);
___FEX_DECL double __stdcall		floatex_todouble(PFLOATEX);
___FEX_DECL ___FEX_I64 __stdcall	floatex_toint64(PFLOATEX);
___FEX_DECL ___FEX_UI64 __stdcall	floatex_touint64(PFLOATEX);
___FEX_DECL void __stdcall 			floatex_storeBCD(PFLOATEX,unsigned char *);

___FEX_DECL long __stdcall 			floatex_tolong_s(PFLOATEX);
___FEX_DECL unsigned long __stdcall	floatex_toulong_s(PFLOATEX);
___FEX_DECL ___FEX_I64 __stdcall	floatex_toint64_s(PFLOATEX);
___FEX_DECL ___FEX_UI64 __stdcall	floatex_touint64_s(PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_longto(long ,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_ulongto(unsigned long ,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_doubleto(double ,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_int64to(___FEX_I64,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_uint64to(___FEX_UI64,PFLOATEX);
___FEX_DECL void __stdcall 	floatex_loadBCD(unsigned char *,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_fval(
									int,___FEX_UI64,unsigned int,int,PFLOATEX);

___FEX_DECL char * __stdcall		floatex_i64toa(___FEX_I64 ,char *,int );
___FEX_DECL char * __stdcall		floatex_ui64toa(___FEX_UI64 ,char *,int );
___FEX_DECL ___FEX_I64 __stdcall	floatex_strtoi64(
										const char *,char **,int ,int *);
___FEX_DECL ___FEX_UI64 __stdcall	floatex_strtoui64(
										const char *,char **,int ,int *);

___FEX_DECL ___FEX_I64 __stdcall	floatex_BCDtoi64(unsigned char *);
___FEX_DECL ___FEX_UI64 __stdcall	floatex_BCDtoui64(unsigned char *);
___FEX_DECL void __stdcall floatex_i64toBCD(___FEX_I64,unsigned char *);
___FEX_DECL void __stdcall floatex_ui64toBCD(___FEX_UI64,unsigned char *);

___FEX_DECL int __stdcall floatex_add64(___FEX_UI64,___FEX_UI64,___FEX_PUI64);
___FEX_DECL int __stdcall floatex_sub64(___FEX_UI64,___FEX_UI64,___FEX_PUI64);
___FEX_DECL int __stdcall floatex_addi64(___FEX_I64,___FEX_I64,___FEX_PI64);
___FEX_DECL int __stdcall floatex_subi64(___FEX_I64,___FEX_I64,___FEX_PI64);

typedef struct { /* 128 bitl */
	___FEX_UI64		lval;
	___FEX_UI64		hval;
} UINT128,*PUINT128;

___FEX_DECL void __stdcall	floatex_ui64x64to128(
								___FEX_UI64,___FEX_UI64,PUINT128);
___FEX_DECL int __stdcall	floatex_ui128div(
								PUINT128,PUINT128,PUINT128,PUINT128);

___FEX_DECL int __stdcall	floatex_ldstr_init(void);
___FEX_DECL void __stdcall	floatex_ldstr_term(void);
___FEX_DECL int __stdcall	floatex_ldstr_ldtoa(PFLOATEX,char *);
___FEX_DECL int __stdcall	floatex_ldstr_ldtoa_f(
								PFLOATEX,
								char		*,
								int 		,
								char		*,
								int 		);
___FEX_DECL int __stdcall	floatex_ldstr_strtold(
								char		*,
								char		**,
								PFLOATEX	);

___FEX_DECL PFLOATEX __stdcall floatex_sin(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_cos(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_tan(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_asin(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_acos(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_atan(PFLOATEX,PFLOATEX);
___FEX_DECL void __stdcall 	floatex_sincos(PFLOATEX,PFLOATEX,PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_sinh(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_cosh(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_tanh(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_asinh(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_acosh(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_atanh(PFLOATEX,PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_sqrt(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_cbrt(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_exp(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_ln(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_log(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_log2(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_pow2(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_pow10(PFLOATEX,PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_pow(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_logxy(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_atan2(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_hypot(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_distance(
							PFLOATEX,PFLOATEX,PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_rotate(
							PFLOATEX,PFLOATEX,PFLOATEX,PFLOATEX,PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_floor(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_ceil(PFLOATEX,PFLOATEX);

___FEX_DECL PFLOATEX __stdcall floatex_dist_normal_u(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_dist_normal_d(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_dist_t_u(int,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_dist_t_d(int,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_dist_chi_u(int,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_dist_chi_d(int,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_dist_f_u(int,int,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_dist_f_d(int,int,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_fact(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_permutation(
									PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_combination(
									PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_lcm(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_gcm(PFLOATEX,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_gamma(PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_jn(int,PFLOATEX,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_yn(int,PFLOATEX,PFLOATEX);

___FEX_DECL int __stdcall	floatex_sum(FLOATEX_TBLPTR,int,PFLOATEX);
___FEX_DECL int __stdcall	floatex_sum_mul(
								FLOATEX_TBLPTR,FLOATEX_TBLPTR,int,PFLOATEX);
___FEX_DECL int __stdcall	floatex_sum_square(FLOATEX_TBLPTR,int,PFLOATEX);
___FEX_DECL int __stdcall	floatex_mean_a(FLOATEX_TBLPTR,int,PFLOATEX);
___FEX_DECL int __stdcall	floatex_mean_g(FLOATEX_TBLPTR,int,PFLOATEX);
___FEX_DECL int __stdcall	floatex_variance(FLOATEX_TBLPTR,int,PFLOATEX);
___FEX_DECL int __stdcall	floatex_maxmin(
								FLOATEX_TBLPTR,int,PFLOATEX,PFLOATEX);
___FEX_DECL FLOATEX_TBLPTR __stdcall	floatex_searchzero(
								FLOATEX_TBLPTR,int,PFLOATEX);
___FEX_DECL FLOATEX_TBLPTR __stdcall	floatex_checktable(
								FLOATEX_TBLPTR,int,unsigned int);

#define FEX_CHKTBL_P_UNSUPPORT	0x0001 /* + T|[gtH[}bg */
#define FEX_CHKTBL_M_UNSUPPORT	0x0002 /* - T|[gtH[}bg */
#define FEX_CHKTBL_P_QNAN		0x0004 /* + ̃NCGbg^ NaN */
#define FEX_CHKTBL_M_QNAN		0x0008 /* - ̃NCGbg^ NaN */
#define FEX_CHKTBL_P_SNAN		0x0010 /* + ̃VOi^ NaN */
#define FEX_CHKTBL_M_SNAN		0x0020 /* - ̃VOi^ NaN */
#define FEX_CHKTBL_P_NORMAL		0x0040 /* + m[} */
#define FEX_CHKTBL_M_NORMAL		0x0080 /* - m[} */
#define FEX_CHKTBL_P_INFINITY	0x0100 /* +  */
#define FEX_CHKTBL_M_INFINITY	0x0200 /* -  */
#define FEX_CHKTBL_P_ZERO		0x0400 /* + 0 */
#define FEX_CHKTBL_M_ZERO		0x0800 /* - 0 */
#define FEX_CHKTBL_P_DENORMAL	0x1000 /* + fm[} */
#define FEX_CHKTBL_M_DENORMAL	0x2000 /* - fm[} */

___FEX_DECL unsigned int __stdcall	floatex_storecw(void);
___FEX_DECL void __stdcall 			floatex_loadcw(unsigned int);
___FEX_DECL unsigned int __stdcall	floatex_storecw2(void);
___FEX_DECL void __stdcall 			floatex_loadcw2(unsigned int);

/* x87 Rg[[hl */
#define FEX_MCW_EM				0x003f /*** 荞ݗO ***/
#define FEX_EM_INVALID			0x0001 /*  */
#define FEX_EM_DENORMAL 		0x0002 /* fm[}EIyh */
#define FEX_EM_ZERODIVIDE		0x0004 /* [Z */
#define FEX_EM_OVERFLOW 		0x0008 /* I[o[t[ */
#define FEX_EM_UNDERFLOW		0x0010 /* A_[t[ */
#define FEX_EM_INEXACT			0x0020 /* smʁixj*/

#define FEX_MCW_RC				0x0c00 /*** ۂߐ ***/
#define FEX_RC_CHOP 			0x0c00 /* [ւ̊ۂ߁i^̐؎̂āj*/
#define FEX_RC_UP				0x0800 /* ؂グi+̕j*/
#define FEX_RC_DOWN 			0x0400 /* ؂̂āi-̕j*/
#define FEX_RC_NEAR 			0x0000 /* ߒlւ̊ۂ߁ij*/

#define FEX_MCW_PC				0x0300 /*** x ***/
#define FEX_PC_24				0x0000 /* 24bit */
#define FEX_PC_53				0x0200 /* 53bit */
#define FEX_PC_64				0x0300 /* 64bit */

typedef struct { /* Rg[[h */
	unsigned int		invalid : 1;
	unsigned int		denormal : 1;
	unsigned int		zerodivide : 1;
	unsigned int		overflow : 1;
	unsigned int		underflow : 1;
	unsigned int		inexact : 1;
	unsigned int		reserved1 : 2;
	unsigned int		precision : 2;
	unsigned int		rounding : 2;
	unsigned int		infinity : 1;
	unsigned int		reserved2 : 3;
} FPU_CONTROL,*PFPU_CONTROL;

typedef union {
	unsigned int		dword;
	FPU_CONTROL			bits;
} FPU_CONTROL_DW,*PFPU_CONTROL_DW;

___FEX_DECL void __stdcall 	floatex_clear87(void);
___FEX_DECL void __stdcall 	floatex_reset(void);
___FEX_DECL void __stdcall 	floatex_reset2(void);
___FEX_DECL PFLOATEX __stdcall floatex_snan(___FEX_UI64,PFLOATEX);
___FEX_DECL PFLOATEX __stdcall floatex_qnan(___FEX_UI64,PFLOATEX);

___FEX_DECL int __stdcall		floatex_examine(PFLOATEX);

#define FEX_EXAM_P_UNSUPPORT	0x0000 /* +T|[gtH[}bg */
#define FEX_EXAM_P_NAN			0x0100 /* +NaN */
#define FEX_EXAM_M_UNSUPPORT	0x0200 /* -T|[gtH[}bg */
#define FEX_EXAM_M_NAN			0x0300 /* -NaN */
#define FEX_EXAM_P_NORMAL		0x0400 /* +l */
#define FEX_EXAM_P_INFINITY 	0x0500 /* + */
#define FEX_EXAM_M_NORMAL		0x0600 /* -l */
#define FEX_EXAM_M_INFINITY 	0x0700 /* - */
#define FEX_EXAM_P_ZERO 		0x4000 /* +0 */
#define FEX_EXAM_M_ZERO 		0x4200 /* -0 */
#define FEX_EXAM_P_DENORMAL 	0x4400 /* +fm[}l */
#define FEX_EXAM_M_DENORMAL 	0x4600 /* -fm[}l */

___FEX_DECL unsigned int __stdcall 	floatex_get_stacktag(void);

/* WX^X^bN̏i[\ */
typedef struct {
	int 		stacktop;
	int 		stackfault;
	int 		tag;
	int 		reserved;
	FLOATEX 	reg[8];
} REGSTACK,*PREGSTACK;

___FEX_DECL PREGSTACK __stdcall		floatex_get_regstack(PREGSTACK);
___FEX_DECL void __stdcall 			floatex_set_regstack(PREGSTACK,int);
___FEX_DECL int __stdcall			floatex_resettag(int);
___FEX_DECL void __stdcall 			floatex_stinit(int);
___FEX_DECL unsigned int __stdcall 	floatex_gettag(FLOATEX_TBLPTR);

typedef struct { /* ^O[h */
	unsigned int		tag0 : 2;
	unsigned int		tag1 : 2;
	unsigned int		tag2 : 2;
	unsigned int		tag3 : 2;
	unsigned int		tag4 : 2;
	unsigned int		tag5 : 2;
	unsigned int		tag6 : 2;
	unsigned int		tag7 : 2;
} FPU_TAG,*PFPU_TAG;

typedef union {
	unsigned int		dword;
	FPU_TAG				bits;
} FPU_TAG_DW,*PFPU_TAG_DW;

___FEX_DECL unsigned int __stdcall 	floatex_get_status(void);

/* Xe[^X[h */
#define FEX_STAT_IE 		1	   /* O */
#define FEX_STAT_DE 		2	   /* fm[}CYhIyh */
#define FEX_STAT_ZE 		4	   /* [Z */
#define FEX_STAT_OE 		8	   /* I[o[t[ */
#define FEX_STAT_UE 		0x10   /* A_[t[ */
#define FEX_STAT_PE 		0x20   /* sm */
#define FEX_STAT_SF 		0x40   /* X^bNtHg */
#define FEX_STAT_ES 		0x80   /* G[T}[Xe[^X */
#define FEX_STAT_C0 		0x100  /* R[hFC0 */
#define FEX_STAT_C1 		0x200  /* R[hFC1 */
#define FEX_STAT_C2 		0x400  /* R[hFC2 */
#define FEX_STAT_C3 		0x4000 /* R[hFC3 */
#define FEX_STAT_B			0x8000 /* FPU rW[ */

#define FEX_STAT_TOP		0x3800 /* X^bNgbvE}XN */
#define FEX_STAT_EXCEPTION	0x7f   /* SOtO */

typedef struct { /* Xe[^X[h */
	unsigned int		invalid : 1;
	unsigned int		denormal : 1;
	unsigned int		zerodivide : 1;
	unsigned int		overflow : 1;
	unsigned int		underflow : 1;
	unsigned int		inexact : 1;
	unsigned int		stackfault : 1;
	unsigned int		errorsummary : 1;
	unsigned int		C0 : 1;
	unsigned int		C1 : 1;
	unsigned int		C2 : 1;
	unsigned int		stacktop : 3;
	unsigned int		C3 : 1;
	unsigned int		busy : 1;
} FPU_STATUS,*PFPU_STATUS;

typedef union {
	unsigned int		dword;
	FPU_STATUS			bits;
} FPU_STATUS_DW,*PFPU_STATUS_DW;

___FEX_DECL void __stdcall 	floatex_fpusave(void *);
___FEX_DECL void __stdcall 	floatex_fpusave2(void *);
___FEX_DECL int __stdcall	floatex_fpuload(void *,int);

typedef struct { /* FPU \ */
	unsigned long		cw;
	unsigned long		stw;
	unsigned long		tw;
	unsigned long		instruction_pointer;
	unsigned short		code_seg;
	unsigned short		opecode;
	unsigned long		operand_adr;
	unsigned short		data_seg;
	unsigned short		reserved1;
	FLOATEX 			reg[8];
	unsigned long		reserved2[5];
} FPU_ENV,*PFPU_ENV;

___FEX_DECL int __stdcall	floatex_exceptionflags(int);
___FEX_DECL void __stdcall	floatex_raise_exception(int,int);
___FEX_DECL int __stdcall	floatex_isempty(void);
___FEX_DECL void __stdcall	floatex_fwait(void);

typedef struct { /* ŌɎsꂽ߂Ɋւ */
	unsigned long		instruction_pointer;
	unsigned long		code_seg;
	unsigned long		operand_adr;
	unsigned long		data_seg;
	unsigned long		opecode;
	unsigned long		reserved[3];
} FPU_LASTCMD,*PFPU_LASTCMD;

___FEX_DECL void __stdcall	floatex_get_lastcmd(PFPU_LASTCMD);

typedef struct { /* o[W */
	unsigned long		fex;
	unsigned long		ldstr;
	unsigned long		reserved[2];
} FLOATEX_VERSION,*PFLOATEX_VERSION;

___FEX_DECL void __stdcall	floatex_get_version(PFLOATEX_VERSION);

/*****************************************************************************/

#ifndef ___FEX_MAKE_CONST
___FEX_DECL extern FLOATEX fex_const_pi;		/*  */
___FEX_DECL extern FLOATEX fex_const_pih;		/*  / 2 */
___FEX_DECL extern FLOATEX fex_const_3pih; 		/* 3 *  / 2 */
___FEX_DECL extern FLOATEX fex_const_2pi;		/* 2 *  */
___FEX_DECL extern FLOATEX fex_const_e;			/* e */
___FEX_DECL extern FLOATEX fex_const_0;			/* 0 */
___FEX_DECL extern FLOATEX fex_const_1;			/* 1 */
___FEX_DECL extern FLOATEX fex_const_2;			/* 2 */
___FEX_DECL extern FLOATEX fex_const_3;			/* 3 */
___FEX_DECL extern FLOATEX fex_const_4;			/* 4 */
___FEX_DECL extern FLOATEX fex_const_5;			/* 5 */
___FEX_DECL extern FLOATEX fex_const_6;			/* 6 */
___FEX_DECL extern FLOATEX fex_const_7;			/* 7 */
___FEX_DECL extern FLOATEX fex_const_8;			/* 8 */
___FEX_DECL extern FLOATEX fex_const_9;			/* 9 */
___FEX_DECL extern FLOATEX fex_const_10;		/* 10 */
___FEX_DECL extern FLOATEX fex_const_05;		/* 0.5 */
___FEX_DECL extern FLOATEX fex_const_epsilon;	/* LDBL_EPSILON */
___FEX_DECL extern FLOATEX fex_const_max;		/* LDBL_MAX */
___FEX_DECL extern FLOATEX fex_const_min;		/* LDBL_MIN */
___FEX_DECL extern FLOATEX fex_const_hugeval;	/* LHUGE_VAL */
___FEX_DECL extern FLOATEX fex_const_i64min;	/* INT64 ̍ŏl */
___FEX_DECL extern FLOATEX fex_const_i64max;	/* INT64 ̍ől */
___FEX_DECL extern FLOATEX fex_const_ui64max;	/* UINT64 ̍ől */
#endif

#ifdef FEX_DISABLE_INT64
#undef ___FEX_I64
#undef ___FEX_PI64
#undef ___FEX_UI64
#undef ___FEX_PUI64
#endif

#ifdef __cplusplus
}
#endif

#endif
